
#ifndef PEAK_H
#define PEAK_H

#define PEAK_LABEL  "peak"


//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//*******************************************************************************


class PeakTrackObj
{
protected:

  double *pointer;
  double T1, T2;

public:

 double peak, peakStored[2];
 double *tptr;
 char   *ID;

 /*
 PeakTrackObj() { ID = 0; }

 const PeakTrackObj& operator=(const PeakTrackObj &PO) {
   peak = old_peak = -1.0; flag = false; Time = 0.0;
   pointer = PO.pointer; T1 = PO.T1; T2 = PO.T2;
   }
 */
    
 PeakTrackObj(TokenString &Param, int i);

 ~PeakTrackObj() { delete [] ID; }

 void set_pointer(TokenString &Param, int i, FieldObj *Ca, BufferArray *Bufs, class KineticObj *KO) { 
   if (!(pointer = ResolveID( Param[ Param.token_index(PEAK_LABEL, i+1) + 1 ], &tptr, Ca, Bufs, KO)) ) { 
     fprintf(stderr,">> PeakTrackObj::set_pointer: cannot resolve pointer [%s]\n",
             Param[Param.token_index(PEAK_LABEL, i+1) + 1]);
     exit(1); 
   }
 }

 double Evaluate();

 void saveState(int level = 0) { peakStored[level] = peak; }
 void recoverState(int level = 0) { peak = peakStored[level]; }
};

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//*******************************************************************************

class PeakTrackArray
{
 public:

  PeakTrackObj **array;
  int          peak_num;

  PeakTrackArray()  { array = 0; peak_num = 0; }

  PeakTrackArray(TokenString &);

  void set_pointers(TokenString &TS, FieldObj *Ca, BufferArray *Bufs, KineticObj *KO);

  /*
  const PeakTrackArray& operator=(const PeakTrackArray& PTA)  {
    if (&PTA != this) { delete [] array; copy(PTA); }
    return *this;
  }

  void copy(const PeakTrackArray &);
  */

  ~PeakTrackArray()  { for (int i=0; i<peak_num; i++) delete array[i];
                       if (peak_num) delete [] array; }  

  void Evaluate()  {
    for (int i = 0; i < peak_num; i++) array[i]->Evaluate();
  }

   void reset()    {
    for (int i = 0; i < peak_num; i++) array[i]->peak = 1e-12;
  }

  void saveState(int level = 0) { for (int i = 0; i < peak_num; i++) array[i]->saveState(level); }
  void recoverState(int level = 0) { for (int i = 0; i < peak_num; i++) array[i]->recoverState(level); }
};

//**************************************************************************

#endif
